QueueControl (ActiveMQ Artemis Web 1.1.0.wildfly-010 API)
Date: 2015-12-18

org.apache.activemq.artemis.api.core.management

## Interface QueueControl

-     public interface QueueControl

  A QueueControl is used to manage a queue.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `changeMessagePriority(long messageID, int newPriority)` Changes the message's priority corresponding to the specified message ID to the specified priority.
    `int` | `changeMessagesPriority(String filter, int newPriority)` Changes the priority for all the message corresponding to the specified filter to the specified priority.
    `long` | `countMessages(String filter)` Counts the number of messages in this queue matching the specified filter.
    `boolean` | `expireMessage(long messageID)` Expires the message corresponding to the specified message ID.
    `int` | `expireMessages(String filter)` Expires all the message corresponding to the specified filter.
    `void` | `flushExecutor()` it will flush one cycle on internal executors, so you would be sure that any pending tasks are done before you call any other measure.
    `String` | `getAddress()` Returns the address this queue is bound to.
    `int` | `getConsumerCount()` Returns the number of consumers consuming messages from this queue.
    `String` | `getDeadLetterAddress()` Returns the dead-letter address associated to this queue.
    `int` | `getDeliveringCount()` Returns the number of messages that this queue is currently delivering to its consumers.
    `String` | `getExpiryAddress()` Returns the expiry address associated to this queue.
    `String` | `getFilter()` Returns the filter associated to this queue.
    `Long` | `getFirstMessageAge()` Returns the age of the first message in milliseconds.
    `String` | `getFirstMessageAsJSON()` Returns the first message on the queue as JSON
    `Long` | `getFirstMessageTimestamp()` Returns the timestamp of the first message in milliseconds.
    `long` | `getID()` Returns this queue ID.
    `long` | `getMessageCount()` Returns the number of messages currently in this queue.
    `long` | `getMessagesAcknowledged()` Returns the number of messages added to this queue since it was created.
    `long` | `getMessagesAdded()` Returns the number of messages added to this queue since it was created.
    `String` | `getName()` Returns the name of this queue.
    `long` | `getScheduledCount()` Returns the number of scheduled messages in this queue.
    `boolean` | `isDurable()` Returns whether this queue is durable.
    `boolean` | `isPaused()` Returns whether the queue is paused.
    `boolean` | `isTemporary()` Returns whether this queue is temporary.
    `String` | `listConsumersAsJSON()`
    `Map<String,Map<String,Object>[]>` | `listDeliveringMessages()` Lists all the messages being deliver per consumer.
    `String` | `listDeliveringMessagesAsJSON()` Executes a conversion of `listDeliveringMessages()` to JSON
    `String` | `listMessageCounter()` Lists the message counter for this queue.
    `String` | `listMessageCounterAsHTML()` Lists the message counter for this queue as a HTML table.
    `String` | `listMessageCounterHistory()` Lists the message counter history for this queue.
    `String` | `listMessageCounterHistoryAsHTML()` Lists the message counter history for this queue as a HTML table.
    `Map<String,Object>[]` | `listMessages(String filter)` Lists all the messages in this queue matching the specified filter.
    `String` | `listMessagesAsJSON(String filter)` Lists all the messages in this queue matching the specified filter using JSON serialization.
    `Map<String,Object>[]` | `listScheduledMessages()` Lists all the messages scheduled for delivery for this queue.
    `String` | `listScheduledMessagesAsJSON()` Lists all the messages scheduled for delivery for this queue using JSON serialization.
    `boolean` | `moveMessage(long messageID, String otherQueueName)` Moves the message corresponding to the specified message ID to the specified other queue.
    `boolean` | `moveMessage(long messageID, String otherQueueName, boolean rejectDuplicates)` Moves the message corresponding to the specified message ID to the specified other queue.
    `int` | `moveMessages(int flushLimit, String filter, String otherQueueName, boolean rejectDuplicates)`
    `int` | `moveMessages(String filter, String otherQueueName)` Moves all the message corresponding to the specified filter to the specified other queue.
    `int` | `moveMessages(String filter, String otherQueueName, boolean rejectDuplicates)` Moves all the message corresponding to the specified filter to the specified other queue.
    `void` | `pause()` Pauses the queue.
    `boolean` | `removeMessage(long messageID)` Removes the message corresponding to the specified message ID.
    `int` | `removeMessages(int flushLimit, String filter)` Removes all the message corresponding to the specified filter.
    `int` | `removeMessages(String filter)` Removes all the message corresponding to the specified filter.
    `void` | `resetMessageCounter()` Resets the message counter for this queue.
    `void` | `resetMessagesAcknowledged()` Resets the MessagesAdded property
    `void` | `resetMessagesAdded()` Resets the MessagesAdded property
    `void` | `resume()` Resumes the queue.
    `int` | `sendMessagesToDeadLetterAddress(String filterStr)` Sends all the message corresponding to the specified filter to this queue's dead letter address.
    `boolean` | `sendMessageToDeadLetterAddress(long messageID)` Sends the message corresponding to the specified message ID to this queue's dead letter address.

- - ### Method Detail

    - #### getName

          String getName()

      Returns the name of this queue.

    - #### getAddress

          String getAddress()

      Returns the address this queue is bound to.

    - #### getID

          long getID()

      Returns this queue ID.

    - #### isTemporary

          boolean isTemporary()

      Returns whether this queue is temporary.

    - #### isDurable

          boolean isDurable()

      Returns whether this queue is durable.

    - #### getFilter

          String getFilter()

      Returns the filter associated to this queue.

    - #### getMessageCount

          long getMessageCount()

      Returns the number of messages currently in this queue.

    - #### getScheduledCount

          long getScheduledCount()

      Returns the number of scheduled messages in this queue.

    - #### getConsumerCount

          int getConsumerCount()

      Returns the number of consumers consuming messages from this queue.

    - #### getDeliveringCount

          int getDeliveringCount()

      Returns the number of messages that this queue is currently delivering to its consumers.

    - #### getMessagesAdded

          long getMessagesAdded()

      Returns the number of messages added to this queue since it was created.

    - #### getMessagesAcknowledged

          long getMessagesAcknowledged()

      Returns the number of messages added to this queue since it was created.

    - #### getFirstMessageAsJSON

          String getFirstMessageAsJSON()
                                throws Exception

      Returns the first message on the queue as JSON
      Throws:
        `Exception`

    - #### getFirstMessageTimestamp

          Long getFirstMessageTimestamp()
                                 throws Exception

      Returns the timestamp of the first message in milliseconds.
      Throws:
        `Exception`

    - #### getFirstMessageAge

          Long getFirstMessageAge()
                           throws Exception

      Returns the age of the first message in milliseconds.
      Throws:
        `Exception`

    - #### getExpiryAddress

          String getExpiryAddress()

      Returns the expiry address associated to this queue.

    - #### getDeadLetterAddress

          String getDeadLetterAddress()

      Returns the dead-letter address associated to this queue.

    - #### listScheduledMessages

          Map<String,Object>[] listScheduledMessages()
                                              throws Exception

      Lists all the messages scheduled for delivery for this queue.
      1 Map represents 1 message, keys are the message's properties and headers, values are the corresponding values.
      Throws:
        `Exception`

    - #### listScheduledMessagesAsJSON

          String listScheduledMessagesAsJSON()
                                      throws Exception

      Lists all the messages scheduled for delivery for this queue using JSON serialization.
      Throws:
        `Exception`

    - #### listDeliveringMessages

          Map<String,Map<String,Object>[]> listDeliveringMessages()
                                                           throws Exception

      Lists all the messages being deliver per consumer.
      The Map's key is a toString representation for the consumer. Each consumer will then return a `Map<String,Object>[]` same way is returned by `listScheduledMessages()`
      Throws:
        `Exception`

    - #### listDeliveringMessagesAsJSON

          String listDeliveringMessagesAsJSON()
                                       throws Exception

      Executes a conversion of `listDeliveringMessages()` to JSON
      Returns:
      Throws:
        `Exception`

    - #### listMessages

          Map<String,Object>[] listMessages(String filter)
                                     throws Exception

      Lists all the messages in this queue matching the specified filter.
      1 Map represents 1 message, keys are the message's properties and headers, values are the corresponding values.
      Using `null` or an empty filter will list all messages from this queue.
      Throws:
        `Exception`

    - #### listMessagesAsJSON

          String listMessagesAsJSON(String filter)
                             throws Exception

      Lists all the messages in this queue matching the specified filter using JSON serialization.
      Using `null` or an empty filter will list all messages from this queue.
      Throws:
        `Exception`

    - #### countMessages

          long countMessages(String filter)
                      throws Exception

      Counts the number of messages in this queue matching the specified filter.
      Using `null` or an empty filter will count all messages from this queue.
      Throws:
        `Exception`

    - #### removeMessage

          boolean removeMessage(long messageID)
                         throws Exception

      Removes the message corresponding to the specified message ID.
      Returns:
        `true` if the message was removed, `false` else
      Throws:
        `Exception`

    - #### removeMessages

          int removeMessages(String filter)
                      throws Exception

      Removes all the message corresponding to the specified filter.
      Using `null` or an empty filter will remove all messages from this queue.
      Returns:
        the number of removed messages
      Throws:
        `Exception`

    - #### removeMessages

          int removeMessages(int flushLimit,
                             String filter)
                      throws Exception

      Removes all the message corresponding to the specified filter.
      Using `null` or an empty filter will remove all messages from this queue.
      Returns:
        the number of removed messages
      Throws:
        `Exception`

    - #### expireMessages

          int expireMessages(String filter)
                      throws Exception

      Expires all the message corresponding to the specified filter.
      Using `null` or an empty filter will expire all messages from this queue.
      Returns:
        the number of expired messages
      Throws:
        `Exception`

    - #### expireMessage

          boolean expireMessage(long messageID)
                         throws Exception

      Expires the message corresponding to the specified message ID.
      Returns:
        `true` if the message was expired, `false` else
      Throws:
        `Exception`

    - #### moveMessage

          boolean moveMessage(long messageID,
                              String otherQueueName)
                       throws Exception

      Moves the message corresponding to the specified message ID to the specified other queue.
      Returns:
        `true` if the message was moved, `false` else
      Throws:
        `Exception`

    - #### moveMessage

          boolean moveMessage(long messageID,
                              String otherQueueName,
                              boolean rejectDuplicates)
                       throws Exception

      Moves the message corresponding to the specified message ID to the specified other queue.
      Returns:
        `true` if the message was moved, `false` else
      Throws:
        `Exception`

    - #### moveMessages

          int moveMessages(String filter,
                           String otherQueueName)
                    throws Exception

      Moves all the message corresponding to the specified filter to the specified other queue. RejectDuplicates = false on this case
      Using `null` or an empty filter will move all messages from this queue.
      Returns:
        the number of moved messages
      Throws:
        `Exception`

    - #### moveMessages

          int moveMessages(String filter,
                           String otherQueueName,
                           boolean rejectDuplicates)
                    throws Exception

      Moves all the message corresponding to the specified filter to the specified other queue.
      Using `null` or an empty filter will move all messages from this queue.
      Returns:
        the number of moved messages
      Throws:
        `Exception`

    - #### moveMessages

          int moveMessages(int flushLimit,
                           String filter,
                           String otherQueueName,
                           boolean rejectDuplicates)
                    throws Exception

      Throws:
        `Exception`

    - #### sendMessageToDeadLetterAddress

          boolean sendMessageToDeadLetterAddress(long messageID)
                                          throws Exception

      Sends the message corresponding to the specified message ID to this queue's dead letter address.
      Returns:
        `true` if the message was sent to the dead letter address, `false` else
      Throws:
        `Exception`

    - #### sendMessagesToDeadLetterAddress

          int sendMessagesToDeadLetterAddress(String filterStr)
                                       throws Exception

      Sends all the message corresponding to the specified filter to this queue's dead letter address.
      Using `null` or an empty filter will send all messages from this queue.
      Returns:
        the number of sent messages
      Throws:
        `Exception`

    - #### changeMessagePriority

          boolean changeMessagePriority(long messageID,
                                        int newPriority)
                                 throws Exception

      Changes the message's priority corresponding to the specified message ID to the specified priority.
      Parameters:
        `newPriority` - between 0 and 9 inclusive.
      Returns:
        `true` if the message priority was changed
      Throws:
        `Exception`

    - #### changeMessagesPriority

          int changeMessagesPriority(String filter,
                                     int newPriority)
                              throws Exception

      Changes the priority for all the message corresponding to the specified filter to the specified priority.
      Using `null` or an empty filter will change all messages from this queue.
      Returns:
        the number of changed messages
      Throws:
        `Exception`

    - #### listMessageCounter

          String listMessageCounter()
                             throws Exception

      Lists the message counter for this queue.
      Throws:
        `Exception`

    - #### resetMessageCounter

          void resetMessageCounter()
                            throws Exception

      Resets the message counter for this queue.
      Throws:
        `Exception`

    - #### listMessageCounterAsHTML

          String listMessageCounterAsHTML()
                                   throws Exception

      Lists the message counter for this queue as a HTML table.
      Throws:
        `Exception`

    - #### listMessageCounterHistory

          String listMessageCounterHistory()
                                    throws Exception

      Lists the message counter history for this queue.
      Throws:
        `Exception`

    - #### listMessageCounterHistoryAsHTML

          String listMessageCounterHistoryAsHTML()
                                          throws Exception

      Lists the message counter history for this queue as a HTML table.
      Throws:
        `Exception`

    - #### pause

          void pause()
              throws Exception

      Pauses the queue. Messages are no longer delivered to its consumers.
      Throws:
        `Exception`

    - #### resume

          void resume()
               throws Exception

      Resumes the queue. Messages are again delivered to its consumers.
      Throws:
        `Exception`

    - #### listConsumersAsJSON

          String listConsumersAsJSON()
                              throws Exception

      Throws:
        `Exception`

    - #### isPaused

          boolean isPaused()
                    throws Exception

      Returns whether the queue is paused.
      Throws:
        `Exception`

    - #### resetMessagesAdded

          void resetMessagesAdded()
                           throws Exception

      Resets the MessagesAdded property
      Throws:
        `Exception`

    - #### resetMessagesAcknowledged

          void resetMessagesAcknowledged()
                                  throws Exception

      Resets the MessagesAdded property
      Throws:
        `Exception`

    - #### flushExecutor

          void flushExecutor()

      it will flush one cycle on internal executors, so you would be sure that any pending tasks are done before you call any other measure. It is useful if you need the exact number of counts on a message

Copyright © 2015. All rights reserved.